<?php

class DillerApp_User
{

    public static function dillerapp_custom_process_order($order_id)
    {
        $settings = get_diller_settings();
        $store_pin = $settings['_store_pin_id'];
        $admin_response = Dillerapp::diller_wc_admin_details();
        $user = wp_get_current_user();
        $coupons = WC()->cart->get_applied_coupons();
        $promo_code = $coupons;
        $transaction_total_amount = WC()->cart->total;
        $order = new WC_Order($order_id);
        $items = $order->get_items();
        $orders = wc_get_order($order_id);
        $created_date = $orders->get_date_created()->date('Y-m-d');
        $created_time = $orders->get_date_created()->date('H:i:s');

        $product_details =  [];

       foreach ( $items as $item_id => $item_data ) {
             $product= $item_data->get_product();
             $active_price   = $product->get_price(); 
             $product_id = $item_data->get_product_id();
             $terms = get_the_terms ( $product_id, 'product_cat' );
             $product_details[] = array(
                'product_id' => $item_data['product_id'],
                'product_name' => $item_data['name'],
                'product_cateogry_id' => !empty($terms) && array_key_exists(0, $terms) && isset($terms[0]->term_taxonomy_id)  ? $terms[0]->term_taxonomy_id : '',
                'product_qty' => wc_get_order_item_meta($item_id, '_qty', true),
                'product_price' => $active_price
            );
         }
        $transaction_details = array(
            "transaction_date" => $created_date,
            "transaction_time" => $created_time,
            "transaction_id" => $order_id,
            "transaction_total_amount" => isset($transaction_total_amount) ? $transaction_total_amount : 0,
            "employee_name" => "",
            "transaction_total_discount_amount" => ""
        );

        $user1 = $order->get_user();
        if (!$user1) {
            $customer_detail = get_post_meta ($order_id);
            $phone = $customer_detail['_billing_phone'][0];
            $country_code1 = '47';
            $result1 = preg_replace("/^\+?{$country_code1}/", '', $phone);
            $mobile = str_replace(" ", "", $result1);
            $request = array(
                'country_code' => '+47',
                'phone' => $mobile,
                'store_id' => $store_pin,
                'receive_sms' => 'Yes',
                'receive_email' => 'Yes',
                'is_purchase_history' => 'Yes',
                'promo_code' => $promo_code,
                'transaction_details' => $transaction_details,
                'product_details' => $product_details
            );

            $data = http_build_query($request);

            $res = Dillerapp::dillerapp_post_request_function($data, 'PosV2/updateFollower');
        }

        if (empty(get_user_meta($user->ID, 'phone', true))) {
            $customer_detail = get_post_meta($order_id);
            $email = $customer_detail['_billing_email'][0];
            $phone = $customer_detail['_billing_phone'][0];
            $first_name = $customer_detail['_billing_first_name'][0];
            $last_name = $customer_detail['_billing_last_name'][0];
            $address = $customer_detail['_billing_address_1'][0];
            $city = $customer_detail['_billing_city'][0];
            $postcode = $customer_detail['_billing_postcode'][0];
            $country = $customer_detail['_billing_country'][0];
            $receive_sms = $customer_detail['sms_check'][0];
            $receive_email = $customer_detail['email_check'][0];
            $privacy_policy = $customer_detail['loyalty_program'][0];
            $is_purchase_history = $customer_detail['is_purchase_history'][0];
            $generated_password = Dillerapp::dillerGenerateStrongPassword();
            $sms_code = $generated_password;
            $request = array(
                'first_name' => $first_name,
                'last_name' => $last_name,
                'email' => $email,
                'phone' => $phone,
                'address' => $address,
                'country' => $country,
                'city' => $city,
                'postcode' => $postcode,
                'store_id' => $store_pin,
                'privacy_policy' => $privacy_policy,
                'is_purchase_history' => ($is_purchase_history ? 'Yes' : 'No'),
                'receive_sms' => ($receive_sms ? 'Yes' : 'No'),
                'receive_email' => ($receive_email ? 'Yes' : 'No'),
                'password' => $sms_code,
                'promo_code' => $promo_code,
                'transaction_details' => $transaction_details,
                'product_details' => $product_details
            );
            
            if ($privacy_policy == 'Yes') {
                $request['receive_sms'] = 'Yes';
                $request['receive_email'] = 'Yes';
                $new_user_id = wp_insert_user(
                    array(
                        'first_name'    => $first_name,
                        'last_name'     => $last_name,
                        'user_login'    => $phone,
                        'user_pass'     => $generated_password,
                        'user_email'    => $email,
                        'user_registered' => date('Y-m-d H:i:s'),
                        'role'        => 'customer'
                    )
                );
                update_user_meta($new_user_id, 'country_code', '+47');
                update_user_meta($new_user_id, 'phone', $phone);
                update_user_meta($new_user_id, 'loyalty_program', 1);
                update_user_meta($new_user_id, 'sms_check', 1);
                update_user_meta($new_user_id, 'email_check', 1);
                update_user_meta($new_user_id, 'is_purchase_history', 1);
                update_user_meta($new_user_id, 'store_id', $admin_response['store_id']);
                update_user_meta($new_user_id, 'mob_no', '+47' . $phone);
                update_user_meta($new_user_id, 'billing_address_1', $address);
                update_user_meta($new_user_id, 'billing_city', $city);
                update_user_meta($new_user_id, 'billing_postcode', $postcode); // was zip_code
                update_user_meta($new_user_id, 'billing_country', $country);
                //update_user_meta($new_user_id, 'country_code', $county);
                //update_user_meta($new_user_id, 'phone', get_user_meta($user->ID, 'phone', true));

                if (is_wp_error($new_user_id)) {
                    $request['is_welcome_sms'] = 1;
                    $user_data = get_user_by('email', $email);
                    if ($user_data) {
                        $new_user_id = $user_data->ID;
                    }
                } else {
                    $request['is_password_sms'] = 1;
                    wp_set_current_user($new_user_id); // set the current wp user
                    wp_set_auth_cookie($new_user_id);
                }

                $data = http_build_query($request);
                $res = Dillerapp::dillerapp_post_request_function($data, 'PosV1/addRegistration');


                if ($res && $res->status == 200) {

                    $is_purchase_history  = isset($request['is_purchase_history']) && $request['is_purchase_history'] == 'Yes'  ? 1 : 0;
                    update_user_meta($new_user_id, 'country_code', $res->response->country_code);
                    update_user_meta($new_user_id, 'phone', $res->response->phone);
                    update_user_meta($new_user_id, 'user_id', $res->response->user_id);
                    update_user_meta($new_user_id, 'loyalty_program', 1);
                    update_user_meta($new_user_id, 'sms_check', 1);
                    update_user_meta($new_user_id, 'email_check', 1);
                    update_user_meta($new_user_id, 'is_purchase_history', 1);
                    update_user_meta($new_user_id, 'store_id', $res->response->store_id);
                    update_user_meta($new_user_id, 'mob_no', $res->response->country_code . $res->response->phone);
                } else {
                    $customer_detail = get_post_meta($order_id);
                    $user = wp_get_current_user();
                    $order_total = $customer_detail['_order_total'][0];
                    update_user_meta($user->ID, 'billing_address_1', $address);
                    update_user_meta($user->ID, 'billing_city', $city);
                    update_user_meta($user->ID, 'billing_postcode', $postcode); // was zip_code
                    update_user_meta($user->ID, 'billing_country', $country);
                    //update_user_meta($user->ID, 'country_code', $county);
                    update_user_meta($user->ID, 'phone', get_user_meta($user->ID, 'phone', true));
                    $request = array(
                        'country_code' => get_user_meta($user->ID, 'country_code', true),
                        'phone' => get_user_meta($user->ID, 'phone', true),
                        'store_id' => $store_pin,
                        'receive_sms' => ($receive_sms ? 'Yes' : 'No'),
                        'receive_email' => ($receive_email ? 'Yes' : 'No'),
                        'is_purchase_history' => ($is_purchase_history ? 'Yes' : 'No'),
                        'promo_code' => $promo_code,
                        'transaction_details' => $transaction_details,
                        'product_details' => $product_details
                    );
                    $data = http_build_query($request);
                    $res = Dillerapp::dillerapp_post_request_function($data, 'PosV2/updateFollower');
                }
            }
        } else {
            $user = wp_get_current_user();
            $request = array(
                'country_code' => get_user_meta($user->ID, 'country_code', true),
                'phone' => get_user_meta($user->ID, 'phone', true),
                'store_id' => $store_pin,
                'receive_sms' => ($receive_sms ? 'Yes' : 'No'),
                'receive_email' => 'Yes', //($receive_email ? 'Yes' : 'No'), // receive_email variable not definde
                'is_purchase_history' => ($is_purchase_history ? 'Yes' : 'No'),
                'promo_code' => $promo_code,
                'transaction_details' => $transaction_details,
                'product_details' => $product_details
            );
            $data = http_build_query($request);
            $res = Dillerapp::dillerapp_post_request_function($data, 'PosV2/updateFollower');
        }
    }

    public static function woocommerce_cart_coupon_list() {
     
     $admin_response=Dillerapp::diller_wc_admin_details();
     
     $login_user=Dillerapp::dillerapp_get_require_param_function();
        if(!empty($admin_response)){
            $store_pin =$admin_response['store_id'];
            $diller_loyalty_program_status=Dillerapp::dillerapp_checked_user_loyalty_status();
            if($diller_loyalty_program_status==1){
              echo do_shortcode('[cart_coupons store_pin="'.$store_pin.'"]');
            }       
        }
   
    }

    public static function dillerapp_save_loyalty_dimension_account_details($user_id)
    {
        $settings = get_diller_settings();
        $admin_response = Dillerapp::diller_wc_admin_details();
        $user = wp_get_current_user();
        $diller_user_id = get_user_meta($user->ID, 'user_id', true);
        $user_follower_id = get_user_meta($user->ID, 'user_follower_id', true);
        $country_code = get_user_meta($user->ID, 'country_code', true);
        $phone = get_user_meta($user->ID, 'phone', true);
        $opt = get_user_meta($user->ID, 'opt', true);
        $newphone = get_user_meta($user->ID, 'newphone', true);

        if (!empty($_POST)) {
            $all_sm_names_arr = array();
            if (isset($_POST['all_sm_names']) && !empty($_POST['all_sm_names'])) {
                $all_sm_names_arr =  explode(',', $_POST['all_sm_names']);
            }

            $segment_value_arr = array();
            $selected_follower_dm_arry = array();
            // set post data into array
            foreach ($_POST as $key => $value) {
                $dm_cheker = explode('#', $key);
                if (count($dm_cheker) == 2) {
                    $selected_follower_dm_arry[] = $key;
                    if ($dm_cheker[0] == 4) {
                        $value = implode(',', $value);
                    }
                    $segment_value_arr[] = array("segment_type" => $dm_cheker[0], "segment_id" => $dm_cheker[1], "segment_value" => $value);
                }
            }

            if (!empty($all_sm_names_arr)) {
                foreach ($all_sm_names_arr as $key => $value) {

                    if (!in_array($value, $selected_follower_dm_arry)) {
                        $dm_cheker = explode('#', $value);
                        $segment_value_arr[] = array("segment_type" => $dm_cheker[0], "segment_id" => $dm_cheker[1], "segment_value" => '');
                    }
                }
            }

            $_POST['store_id'] = $admin_response['store_id'];
            $_POST['first_name'] = $_POST['account_first_name'];
            $_POST['last_name'] = $_POST['account_last_name'];
            $_POST['email'] = $_POST['account_email'];
            $_POST['phone'] = $_POST['phone'];
            $_POST['country_code'] = $_POST['country_code'];
            $_POST['change_country_code'] = $_POST['country_code'];
            $_POST['segment_details'] = $segment_value_arr;
             $data = http_build_query(sanitize_post($_POST));
             $check_phone = Dillerapp::dillerapp_post_request_function($data, 'PosV1/checkFollowerPhoneNew');
           if(!empty($check_phone->result->user_id)){
              $hidden_val= $check_phone->result->user_id;
              $_POST['q_hidden_val']= print_r($hidden_val);
              $data = http_build_query(sanitize_post($_POST));
              $res = Dillerapp::dillerapp_post_request_function($data, 'PosV2/updateFollower');
              update_user_meta($user_id, 'loyalty_program', 1);
              update_user_meta($user_id,'country_code',$_POST['country_code']);
              update_user_meta($user_id,'phone',$_POST['phone']);
              update_user_meta( $user_id, 'mob_no', sanitize_text_field($_POST['country_code'].$_POST['phone']));
              update_user_meta($user_id, 'sms_check',1);
              update_user_meta($user_id, 'email_check',1);
              update_user_meta($user_id, 'is_purchase_history',1);
            
            }
             
            else if (empty($country_code) && empty($phone)) {
                $_POST['receive_sms'] = 'Yes';
                $_POST['receive_email'] = 'Yes';
                $_POST['is_welcome_sms'] = 1;
                $data = http_build_query(sanitize_post($_POST));
                $res = Dillerapp::dillerapp_post_request_function($data, 'PosV1/addRegistration');
            }
            
             else if(!empty($_POST['otp'])){
                $_POST['opt'] = $_POST['opt'];
                $_POST['change_phone'] = $_POST['newphone'];
                $data = http_build_query(sanitize_post($_POST));
                $res = Dillerapp::dillerapp_post_request_function($data, 'PosV1/VerifyChangePhoneNumber');
            } else {
                $data = http_build_query(sanitize_post($_POST));
                if (!empty($_POST['privacy_policy'])) {
                    $res = Dillerapp::dillerapp_post_request_function($data, 'PosV2/updateFollower');
                } else {
                    $request = Dillerapp::dillerapp_get_require_param_function();
                    $res_del = Dillerapp::dillerapp_post_request_function($request, 'PosV1/deleteFollower');
                    if ($res_del && $res_del->status == 200) {
                        update_user_meta($user_id, 'loyalty_program', 0);
                        update_user_meta($user_id, 'sms_check', 0);
                        update_user_meta($user_id, 'email_check', 0);
                        update_user_meta($user_id, 'is_purchase_history', 0);
                        update_user_meta($user_id, 'user_follower_id', '');
                        update_user_meta($user_id, 'country_code', '');
                        update_user_meta($user_id, 'phone', '');
                        update_user_meta($user_id, 'user_id', '');
                        update_user_meta($user_id, 'store_id', '');
                    } else {
                        WC()->session->set('wc_notices', null);
                        wc_add_notice($res->message, 'error');
                    }
                }
            }
          if($res && $res->status == 200){
          $is_purchase_history  = isset($_POST['is_purchase_history'])  ? 1: 0;
          $receive_sms  = isset($_POST['receive_sms'])  ? 1: 0;
          $receive_email  = isset($_POST['receive_email'])  ? 1: 0;
          update_user_meta( $user_id, 'loyalty_program', 1);        
          update_user_meta($user_id,'country_code',$_POST['country_code']);
          $diller_loyalty_program_status=Dillerapp::dillerapp_checked_user_loyalty_status();
          if($diller_loyalty_program_status==0 || (!empty($_POST['otp']))){
          update_user_meta($user_id,'phone',$_POST['newphone']);
          update_user_meta( $user_id, 'mob_no', sanitize_text_field($_POST['country_code'].$_POST['newphone']));
         }else{
          update_user_meta($user_id,'phone',$_POST['phone']);
          update_user_meta( $user_id, 'mob_no', sanitize_text_field($_POST['country_code'].$_POST['phone']));
         }
          update_user_meta($user_id, 'sms_check',sanitize_text_field($receive_sms));
          update_user_meta($user_id, 'email_check',sanitize_text_field($receive_email));
          update_user_meta($user_id, 'is_purchase_history',sanitize_text_field($is_purchase_history));
        }else{
          WC()->session->set( 'wc_notices', null );
          wc_add_notice( $res->message, 'error' );    
        }
            wp_safe_redirect(wc_get_endpoint_url('edit-account'));
            exit;
        }
    }

    public static  function dillerapp_add_new_subscriber()
    {

        $admin_response = Dillerapp::diller_wc_admin_details();

        if (isset($_POST["email"]) && isset($_POST['pippin_subscribe_nonce']) && wp_verify_nonce($_POST['pippin_subscribe_nonce'], 'pippin-subscribe-nonce')) {

            $first_name   = sanitize_text_field($_POST["first_name"]);
            $last_name   = sanitize_text_field($_POST["last_name"]);
            $user_login   = sanitize_text_field($_POST["phone"]);
            $user_email   = sanitize_email($_POST["email"]);
            $privacy_policy   = sanitize_text_field($_POST['privacy_policy']);
            $q_hidden_val = sanitize_text_field($_POST["q_hidden"]);

            if ($user_login == '') {
                // empty phone
                dillerapp_errors()->add('phone_empty', __('Please enter a phone'));
            }
            if ($first_name == '') {
                // empty phone
                dillerapp_errors()->add('first_name_empty', __('Please enter a first name'));
            }
            if ($last_name == '') {
                // empty phone
                dillerapp_errors()->add('last_name_empty', __('Please enter a last name'));
            }
            if (!is_email($user_email)) {
                //invalid email
                dillerapp_errors()->add('email_invalid', __('Invalid email'));
            }
            if ($privacy_policy == 'No') {
                // passwords do not match
                dillerapp_errors()->add('privacy_policy_empty', __('Please accept the privacy policy.'));
            }

            $errors = dillerapp_errors()->get_error_messages(); 
            if (empty($errors)) {
                //$created_date = date('Y-m-d H:i:s');
                $generated_password = Dillerapp::dillerGenerateStrongPassword();
                $dillerapp_wp_user = get_user_by('email', $user_email);
    
                if (is_a($dillerapp_wp_user, "WP_User") && !diller_check_for_user_in_site(get_current_blog_id(), $dillerapp_wp_user->ID)) {
                    $random_email = rand(0, 1000) . '_fake_nexwee@email.com';
                    $new_customer_data = diller_new_customer_data($user_email, $generated_password, $random_email);
                    $new_user_id = wp_insert_user($new_customer_data);
                    if (is_wp_error($new_user_id)) {
                        $message = 'ERROR1: ' . $new_user_id->get_error_message() . ' email: ' . $random_email . ' generated_password: ' . $generated_password;
                        DilleApp_Logger::instance()->add("settings: " . print_r($message, true));
                        return;
                    }

                    $_POST['is_welcome_sms'] = 1;
                    if (is_multisite()) { // if (!empty($admin_response['multisite_disable'])) {
                        $_POST['is_password_sms']   = 1;
                        $_POST['store_id']          = $admin_response['store_id'];
                        $_POST['password']          = $generated_password;
                        $_POST["email"]             = $user_email;
                        $data1                      = http_build_query(sanitize_post($_POST));

                        $res1 = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/addRegistration');

                        if ($res1) {
                            $is_purchase_history  = isset($_POST['is_purchase_history'])  ? 1 : 0;
                            update_user_meta($new_user_id, 'loyalty_program', 1);
                            update_user_meta($new_user_id, 'mob_no', sanitize_text_field($_POST['country_code'] . $user_login));
                            update_user_meta($new_user_id, 'sms_check', 1);
                            update_user_meta($new_user_id, 'email_check', 1);
                            update_user_meta($new_user_id, 'is_purchase_history', sanitize_text_field($is_purchase_history));
                            update_user_meta($new_user_id, 'country_code', $_POST['country_code']);
                            update_user_meta($new_user_id, 'phone', $_POST['phone']);
                        }

                        $customer = new WC_Customer($new_user_id);
                        $customer->set_first_name($first_name);
                        $customer->set_last_name($last_name);
                        $customer->set_last_name($last_name);
                        $customer->set_billing_phone(isset($_POST['phone']) ? $_POST['phone'] : $user_login);
                        $customer->set_billing_email($user_email);
                        $customer->save();

                        wp_set_current_user($new_user_id); // set the current wp user
                        wp_set_auth_cookie($new_user_id); // start the cookie for the current registered user
                        //wp_redirect($admin_response['language'] == 2 ? 'my-account' : 'min-konto');
                        wp_redirect(wc_get_page_permalink('myaccount'));
                        die();
                    }
                } else {
                  $user_name = sanitize_user($user_email, true);
                   $new_user_id = wp_insert_user(array(
                    'first_name'    => $first_name,
                    'last_name'     => $last_name,
                    'user_login'    => $user_email,
                    'user_pass'     => $generated_password,
                    'user_email'    => $user_email,
                    'user_registered' => date('Y-m-d H:i:s'),
                    'role'        => 'customer'
                  )
                );
                    if (is_wp_error($new_user_id)) {
                        if (!empty($admin_response['multisite_disable'])) {
                        $random_email = rand(0, 1000) . '_fake_nexwee@email.com';
                        $new_customer_data = diller_new_customer_data($user_email, $generated_password, $random_email, $first_name, $last_name);
                        $new_user_id = wp_insert_user($new_customer_data);
                        if(isset($_POST['q_hidden'])){
                            $_POST['q_hidden_val']=sanitize_post($_POST['q_hidden']);
                        }
                        $_POST['store_id'] = $admin_response['store_id'];
                        $_POST['password'] = $generated_password;
                        $data1 = http_build_query(sanitize_post($_POST));
                        $res1 = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/addRegistration');
                        if ($res1) {
                            $is_purchase_history  = isset($_POST['is_purchase_history'])  ? 1 : 0;
                            update_user_meta($new_user_id, 'loyalty_program', 1);
                            update_user_meta($new_user_id, 'mob_no', sanitize_text_field($_POST['country_code'] . $user_login));
                            update_user_meta($new_user_id, 'sms_check', 1);
                            update_user_meta($new_user_id, 'email_check', 1);
                            update_user_meta($new_user_id, 'is_purchase_history', sanitize_text_field($is_purchase_history));
                            update_user_meta($new_user_id, 'country_code', $_POST['country_code']);
                            update_user_meta($new_user_id, 'phone', $_POST['phone']);
                            //wp_new_user_notification($new_user_id); 
                        }
                        $_POST['is_welcome_sms'] = 1;
                        wp_set_current_user($new_user_id); // set the current wp user
                        wp_set_auth_cookie($new_user_id); // start the cookie for the current registered user
                        //wp_redirect($admin_response['language'] == 2 ? 'my-account' : 'min-konto');
                        wp_redirect(wc_get_page_permalink('myaccount'));
                        die();

                        }else{

                        $user      = wp_get_current_user();
                        $wc_permalink = wc_get_page_permalink('myaccount');
                        $error_message = $admin_response['language'] == 2 ? 'Congratulations! You are now registered successfully in our loyalty program. You can access your loyalty program status and benefits by logging in with your existing WordPress account. We will redirect you automatically in 10 seconds or <a href="' . $wc_permalink . '">click here</a>' : 'Gratulerer! Du er nå registrert i vårt lojalitetsprogram.  Du kan se din medlemsstatus og fordeler ved å logge inn med din eksisterende Wordpress bruker. Vi vil videresende deg automatisk til login siden om 10 sekunder eller du kan <a href="' . $wc_permalink . '">klikke her nå for å logge inn.</a>';
                       header( "refresh:10;" .$wc_permalink);
                       dillerapp_errors()->add('Failed', __($error_message));
                        if(isset($_POST['q_hidden'])){
                            $_POST['q_hidden_val']=sanitize_post($_POST['q_hidden']);
                        }
                        $_POST['store_id'] = $admin_response['store_id'];
                        $_POST['password'] = $generated_password;
                        $data1 = http_build_query(sanitize_post($_POST));
                        $res1 = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/addRegistration');
                        $message = 'ERROR2: ' . $new_user_id->get_error_message();
                        DilleApp_Logger::instance()->add("settings: " . print_r($message, true));
                        return;
                    }
                }
                    $_POST['is_password_sms'] = 1;
                }

//                 $customer = new WC_Customer($new_user_id);
//                 $customer->set_first_name($first_name);
//                 $customer->set_last_name($last_name);
//                 $customer->set_last_name($last_name);
//                 $customer->set_billing_phone(isset($_POST['phone']) ? $_POST['phone'] : $user_login);
//                 $customer->set_billing_email($user_email);
//                 $customer->save();

                $all_sm_names_arr = array();

                if (isset($_POST['all_sm_names']) && !empty($_POST['all_sm_names'])) {
                    $all_sm_names_arr =  explode(',', $_POST['all_sm_names']);
                }

                $segment_value_arr = array();
                $selected_follower_dm_arry = array();
                // set post data into array
                foreach ($_POST as $key => $value) {

                    $dm_cheker = explode('#', $key);
                    if (count($dm_cheker) == 2) {
                        $selected_follower_dm_arry[] = $key;
                        if ($dm_cheker[0] == 4) {
                            $value = implode(',', $value);
                        }
                        $segment_value_arr[] = array("segment_type" => $dm_cheker[0], "segment_id" => $dm_cheker[1], "segment_value" => $value);
                    }
                }

                if (!empty($all_sm_names_arr)) {
                    foreach ($all_sm_names_arr as $key => $value) {
                        if (!in_array($value, $selected_follower_dm_arry)) {
                            $dm_cheker = explode('#', $value);
                            $segment_value_arr[] = array("segment_type" => $dm_cheker[0], "segment_id" => $dm_cheker[1], "segment_value" => '');
                        }
                    }
                }

                $_POST['store_id'] = $admin_response['store_id'];
                $_POST['password'] = $generated_password;
                $_POST['q_hidden_val'] = $q_hidden_val;
                $_POST['segment_details'] = $segment_value_arr;

                $data1 = http_build_query(sanitize_post($_POST));

                if (!empty($q_hidden_val)) {
                    $res1 = Dillerapp::dillerapp_post_request_function($data1, 'PosV2/updateFollower');
                } else {
                    $res1 = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/addRegistration');
                }

                if ($res1) {
                    $is_purchase_history  = isset($_POST['is_purchase_history'])  ? 1 : 0;
                    update_user_meta($new_user_id, 'loyalty_program', 1);
                    update_user_meta($new_user_id, 'mob_no', sanitize_text_field($_POST['country_code'] . $user_login));
                    update_user_meta($new_user_id, 'sms_check', 1);
                    update_user_meta($new_user_id, 'email_check', 1);
                    update_user_meta($new_user_id, 'is_purchase_history', sanitize_text_field($is_purchase_history));
                    update_user_meta($new_user_id, 'country_code', $_POST['country_code']);
                    update_user_meta($new_user_id, 'phone', $_POST['phone']);
                    //wp_new_user_notification($new_user_id); 
                }
                $wc_permalink = wc_get_page_permalink('myaccount');

                if (isset($dillerapp_wp_user->ID)) {

                    $error_message = $admin_response['language'] == 2 ? 'Congratulations! You are now registered successfully in our loyalty program. You can access your loyalty program status and benefits by logging in with your existing WordPress account. We will redirect you automatically in 10 seconds or <a href="' . $wc_permalink . '">click here</a>' : 'Gratulerer! Du er nå registrert i vårt lojalitetsprogram.  Du kan se din medlemsstatus og fordeler ved å logge inn med din eksisterende Wordpress bruker. Vi vil videresende deg automatisk til login siden om 10 sekunder eller du kan <a href="' . $wc_permalink . '">klikke her nå for å logge inn.</a>';
                    dillerapp_errors()->add('Failed', __($error_message));
                    //header("refresh:10;" . $dillerapp_redirect_url);
                } else {
                    wp_set_current_user($new_user_id); // set the current wp user
                    wp_set_auth_cookie($new_user_id); // start the cookie for the current registered user
                    // wp_redirect($admin_response['language'] == 2 ? 'my-account' : 'min-konto');
                    // exit;
                }
                wp_redirect($wc_permalink);
                die();
            }
        }
    }
    
    public static function dillerapp_my_dashboard_addition()
    {
        $admin_response = Dillerapp::diller_wc_admin_details();
        $my_level = '';
        $point = 0;
        $point_expire_detail = '';
        $next_level = '';
        $next_level_point = 0;
        $total_earn_point = 0;
        $level_created_date = '';
        $level_expire_date = '';
        //$order_statuses = array('wc-on-hold', 'wc-processing', 'wc-completed');
        $body = Dillerapp::dillerapp_get_require_param_function();
        $point_bar_color = '';
        $storeData = Dillerapp::dillerapp_post_request_function($body,'PosV1/getStoreDetails');
        if ($storeData && $storeData->status == 200) {
            if ($storeData->result->point_system == 1) {
                if (isset($storeData->result->point_bar_color) && !empty($storeData->result->point_bar_color)) {
                    $point_bar_color = Dillerapp::store_details_point_bar_color();
                }

                if (isset($storeData->result->store_language) && !empty($storeData->result->store_language)) {
                    $language = $storeData->result->store_language;
                }
                $followerData = Dillerapp::dillerapp_post_request_function($body, 'PosV2/getFollower');

                if ($followerData && $followerData->status == 200) {

                    if (isset($followerData->result->membershipDetails->current_membership_level_title) && !empty($followerData->result->membershipDetails->current_membership_level_title)) {
                        $my_level = $followerData->result->membershipDetails->current_membership_level_title;
                    }

                    if (isset($followerData->result->membershipDetails->points) && !empty($followerData->result->membershipDetails->points)) {
                        $point = $followerData->result->membershipDetails->points;
                    }

                    if (isset($followerData->result->membershipDetails->point_expiry_details) && !empty($followerData->result->membershipDetails->point_expiry_details)) {
                        $point_expire_detail = $followerData->result->membershipDetails->point_expiry_details;
                    }
                    if (isset($followerData->result->membershipDetails->next_membership_level_title) && !empty($followerData->result->membershipDetails->next_membership_level_title)) {
                        $next_level = $followerData->result->membershipDetails->next_membership_level_title;
                    }

                    if (isset($followerData->result->membershipDetails->next_membership_level_require_points) && !empty($followerData->result->membershipDetails->next_membership_level_require_points)) {
                        $next_level_point = $followerData->result->membershipDetails->next_membership_level_require_points;
                    }

                    if (isset($followerData->result->membershipDetails->total_earn_point) && !empty($followerData->result->membershipDetails->total_earn_point)) {
                        $total_earn_point = $followerData->result->membershipDetails->total_earn_point;
                    }

                    if (isset($followerData->result->membershipDetails->level_created_date) && !empty($followerData->result->membershipDetails->level_created_date)) {
                        $level_created_date = $followerData->result->membershipDetails->level_created_date;
                    }

                    if (isset($followerData->result->membershipDetails->member_level_expiry_details) && !empty($followerData->result->membershipDetails->member_level_expiry_details)) {
                        $level_expire_date = $followerData->result->membershipDetails->member_level_expiry_details;
                    }
?>

                    <div class="diller-div-bg">
                        <div class="diller-container diller-div">
                            <div class="diller-row">
                                <h4 class="diller-w-100"><?= LOYALTY_PROGRAM_STATUS ?></h4>
                                <span class="diller-w-100 diller-mb-2"><?= MY_LEVEL ?>: <span><b><?= $my_level ?></b></span></span>
                                <span class="diller-w-100 diller-mb-2"><?= POINTS_FOR_USE ?>: <span><b><?= $point ?> <?= POINTS ?></b></span>
                                    <?php if ($level_expire_date) { ?>
                                        <span class="diller-tooltip"><u>(<?= SEE_EXPIRATION ?>)</u></span>
                                        <div class="diller-hide"><?= $point_expire_detail ?></div>
                                    <?php } ?>
                                </span>
                                <span class="diller-w-100 diller-mb-2"><?= POINTS_TILL_NEXT_LEVEL ?> (<?= $next_level ?>): <span><?= $next_level_point ?> <?= POINTS ?></span></span>
                                <span class="diller-w-100 diller-mb-2 diller-mt-4"><?= POINTS_EARNED_FOR_THE_PERIOD ?>(<?= $total_earn_point ?> <?= POINTS ?>): </span>
                            </div>
                            <div class="diller-row diller-pt-4 diller-pb-4 diller-progrress-row diller-div">
                                <?php
                                $level_point_div = '';
                                $level_name_div = '';
                                $follower_percent = 0;

                                if (isset($storeData->result->membership_level_details) && !empty($storeData->result->membership_level_details)) {

                                    $last_level =  end($storeData->result->membership_level_details);
                                    $last_level_point =  $last_level->membership_level_points;

                                    $follower_percent =   $total_earn_point * 100 / $last_level_point;
                                    $follower_percent =  $follower_percent > 100 ? 100 : $follower_percent;

                                    foreach ($storeData->result->membership_level_details as $key => $membership_level_details) {

                                        $percent =   $membership_level_details->membership_level_points * 100 / $last_level_point;
                                        $percent =  $percent > 100 ? 100 : $percent;

                                        if ($percent != 100) {

                                            $level_point_div .=   '<div class="diller-level-div diller-level-top diller-div" style="left:' . $percent . '%">
                                                  ' . $membership_level_details->membership_level_points . '
                                                 </div>';

                                            $level_name_div .=    '<div class="diller-level-div diller-level-bottom diller-div" style="left: ' . $percent . '%;" >
                                                     ' . trim($membership_level_details->membership_level_title) . '
                                                  </div>';
                                        } else {

                                            $level_point_div .=   '<div class="diller-level-div diller-level-top diller-div diller-text" style="right:0%">
                                                  ' . $membership_level_details->membership_level_points . '
                                                 </div>';

                                            $level_name_div .=    '<div class="diller-level-div diller-level-bottom diller-div diller-text" style="right:0%;" >
                                                     ' . trim($membership_level_details->membership_level_title) . '
                                                  </div>';
                                        }
                                    }
                                }

                                echo $level_point_div;

                                echo '  <span class="diller-progress">
                       <div class="diller-second-progress" style="width : ' . $follower_percent . '%;background-color: ' . $point_bar_color . ';" ></div>
                     </span>';

                                echo $level_name_div;

                                ?>
                                <br>
                                <br>
                                <span class="diller-w-100 diller-mb-2 diller-mt-4"><?= MEMBER_LEVEL_QUALIFICATION_PERIOD ?>: <?php if ($level_expire_date != '') { ?> <?= $level_created_date ?> - <?= $level_expire_date ?> <?php } else { ?> <?= NEVER_EXPIRE ?> <?php }  ?></span>
                            </div>
                        </div>
                    </div>
                <?php } else { ?>
                    <div class="diller-div-bg">
                        <div class="container diller-div">
                            <div class="diller-row">
                                <?php
                                $diller_loyalty_program_status=Dillerapp::dillerapp_checked_user_loyalty_status();
                                if($diller_loyalty_program_status==1){ ?>
                                <h4 class="diller-w-100"><?= ($admin_response['language'] == 2 ? 'You are a member of our loyalty program and are now receive the best benefits.' : 'Du er medlem av vår kundeklubb og får nå de beste fordelene hos oss!'); ?></h4>
                                <?php 
                                } else{ ?>
                                <h4 class="diller-w-100"><?= ($admin_response['language'] == 2 ? 'Join our loyalty program to enjoy great benefits.' : 'Bli medlem av vår kundeklubb for å få eksklusive fordeler hos oss.'); ?></h4>
                                <?php 

                                    $user_ID   = get_current_user_id();
                                    $user      = wp_get_current_user();
                                    ?>
                                    <form method="post" id="adduser" action="<?php the_permalink(); ?>">
                                        <div class="container">
                                            <div class="diller-form-group">
                                                <label><?= FIRST_NAME; ?> <span class="diller-form-required">*</span></label>
                                                <input type="text" name="first_name" class="diller-form-control" value="<?php echo $user->first_name; ?>" required>
                                            </div>

                                            <div class="diller-form-group">
                                                <label><?= LAST_NAME; ?> <span class="diller-form-required">*</span></label>
                                                <input type="text" placeholder="<?= LAST_NAME; ?>" name="last_name" class="diller-form-control" value="<?php echo $user->last_name; ?>" required>
                                            </div>
                                            <input type="hidden" name="country_code" id="country_code">
                                            <div class="diller-form-group">
                                                <label><?= PHONE; ?> <span class="diller-form-required">*</span></label>
                                                <?php
                                                $phone_post = '';
                                                $phone_post .= isset($_POST['country_code']) ? $_POST['country_code'] : '';
                                                $phone_post .= isset($_POST['phone']) ? $_POST['phone'] : '';
                                                $phone_post = $phone_post != '' ? $phone_post : "+47";
                                               // $privacy_policy = isset($_POST['loyalty_program']);
                                                ?>
                                                <input type="tel" id="phone" name="phone" value="<?= $user->mob_no!='' ? $user->mob_no :'+47' ?>"  class="diller-form-control" required>
                                                <span class="diller-error" id="phone_error"></span>
                                            </div>

                                        </div>

                                        <?php Dillerapp::dillerapp_show_dimension_details();
                                        Dillerapp::dillerapp_show_checkboxes('account');
                                        ?>
                            </div>


                            <input type="hidden" name="pippin_update_nonce" value="<?php echo wp_create_nonce('pippin-update-nonce'); ?>" />
                            <input name="updateuser" type="submit" id="updateuser" class="submit button" value="<?php _e('Update', 'profile'); ?>" />
                            </form>

                            <?php if  (isset($_POST['pippin_update_nonce']) && wp_verify_nonce($_POST['pippin_update_nonce'], 'pippin-update-nonce')) {  ?>

                           <?php 
                            $phone_country = $_POST['country_code']!='' ? $_POST['country_code'] : "+47";
                            $_POST['store_id']      = $admin_response['store_id'];
                            $_POST['first_name']    = $_POST['first_name'];
                            $_POST['last_name']     = $_POST['last_name'];
                            $_POST['email']         = $user->user_email;
                            $_POST['country_code']  = $phone_country;
                            $_POST['phone']         = $_POST['phone'];
                            
                            $privacy_policy   = 'Yes';
                            $data1 = http_build_query(sanitize_post($_POST));
                            $check_phone = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/checkFollowerPhoneNew');
                            
                            if(!empty($check_phone->result->user_id)){
                            $hidden_val1= $check_phone->result->user_id;
                            $_POST['q_hidden_val']= print_r($hidden_val1);
                            $data = http_build_query(sanitize_post($_POST));
                            $res = Dillerapp::dillerapp_post_request_function($data, 'PosV2/updateFollower');
                          
                            } else{
                         
                            $res = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/addRegistration');
                            }
                            $phone_country = $_POST['country_code']!='' ? $_POST['country_code'] : "+47";
                      
                            update_user_meta( $user_ID, 'mob_no', $phone_country.$_POST['phone']);

                            update_user_meta($user_ID,'country_code',$_POST['country_code']!='' ? $_POST['country_code'] : "+47" );
                            
                            update_user_meta($user_ID,'phone',$_POST['phone']);
                            update_user_meta($user_ID,'first_name', trim( $_POST['first_name'] ));
                            update_user_meta($user_ID,'last_name',trim( $_POST['last_name'] ));
                      
                            if (isset($_POST['privacy_policy'])) {
                                update_user_meta($user_ID, 'loyalty_program', 1);
                            }
                          
                          update_user_meta($user_ID, 'sms_check', 1 );
                          update_user_meta($user_ID, 'email_check', 1 );
                         
                          update_user_meta($user_ID,'store_id',$_POST['store_id']);
                          if (isset($_POST['is_purchase_history'])) {
                          update_user_meta($user_ID,'is_purchase_history',1);
                          } 
                          update_user_meta($user_ID,' _order_count',0);
                       
                          wp_safe_redirect(wc_get_account_endpoint_url('dashboard') );
                          exit();
                           } } ?>

                        </div>
                    </div>
                    </div>
<?php }
            }
        }
    }
}
  