<?php
class Dillerapp
{
	const API_URL = 'https://diller.app/api/';
	const SERVER = "Production";
	const DILLER_CIPHERING = "AES-128-CTR";
	const DILLER_CI_OPTION = 0;
	const DILLER_ENCRYPTION_IV = '2334587974566325';
	const DILLER_ENCRYPTION_KEY = "DillerLoyalty";

	public static function diller_wc_admin_details()
	{
		$settings = get_diller_settings();
		$store_pin = $settings['_store_pin_id'];

 		$ciphering = Dillerapp::DILLER_CIPHERING;
		$options = Dillerapp::DILLER_CI_OPTION;
		$encryption_iv = Dillerapp::DILLER_ENCRYPTION_IV;
		$encryption_key = Dillerapp::DILLER_ENCRYPTION_KEY;


		$language = $settings['_choose_language_id'];
		$store_pin = $settings['_store_pin_id'];
		$skeleton_css = $settings['_disable_skeleton_css'];
		$multisite_disable = $settings['_disable_multisite'];

		$x_api_key = openssl_decrypt($settings['x_api_key'], $ciphering, $encryption_key, $options, $encryption_iv);
		return [
			'store_id' => $store_pin,
			'language' => $language,
			'skeleton_css' => $skeleton_css,
			'multisite_disable' => $multisite_disable,
			'x_api_key' => $x_api_key,
		];
	}


	/**
	 * dillerapp_post_request_function
	 *
	 * @param  mixed $body
	 * @param  mixed $url
	 * @param  mixed $output_type
	 * @return json object or false if faild
	 */
	public static function dillerapp_post_request_function($body, $url, $output_type = NULL)
	{
		$settings = get_diller_settings();
		if (!$settings || empty($settings)) return false;

		$api_key = $settings['x_api_key'];
		if (empty($api_key)) return false;


		$url = self::API_URL . $url;

		if (!empty($body)) {
			if (is_array($body)) {
				$body['subscribe_by'] = "WEBSHOP";
			} else {
				$body = $body . '&subscribe_by=WEBSHOP';
			}
		}

		$ciphering = Dillerapp::DILLER_CIPHERING;
		$iv_length = openssl_cipher_iv_length(Dillerapp::DILLER_CIPHERING);
		$options = Dillerapp::DILLER_CI_OPTION;
		$encryption_iv = Dillerapp::DILLER_ENCRYPTION_IV;
		$encryption_key = Dillerapp::DILLER_ENCRYPTION_KEY;
		$x_api_key = openssl_decrypt($api_key, $ciphering, $encryption_key, $options, $encryption_iv);

		$args = array(
			'body'        => $body,
			'timeout'     => '5',
			'redirection' => '5',
			'httpversion' => '1.0',
			'blocking'    => true,
			'headers'     => array('x-api-key' => $x_api_key),
			'cookies'     => array(),
		);
		$response = wp_remote_post($url, $args);
		if (!is_wp_error($response)) {
			if ($output_type == 'array') {
				$res = json_decode($response['body'], true);
 			} else {
				$res = json_decode($response['body']);
			}
			return $res;
		} else {
			return FALSE;
		}
	}

	public static function dillerapp_checked_user_loyalty_status()
	{
		$user = wp_get_current_user();
		if (isset($user->ID)) {
			return $diller_loyalty_program = get_user_meta($user->ID, 'loyalty_program', true);
		} else {
			return FALSE;
		}
	}


	public static function dillerapp_get_require_param_function()
	{
		 $user_id = get_current_user_id();
		 $settings = get_diller_settings();
		 $store_pin = $settings['_store_pin_id'];
			$empty = [
				'store_id' => $store_pin,
				'country_code' => '',
				'phone' => '',
			];
			if (!$user_id){
				return $empty;
			} 
			
			$country_code = get_user_meta($user_id, 'country_code', true);
			$phone = get_user_meta($user_id, 'phone', true);
			return [
				'store_id' => $store_pin ? $store_pin : '',
				'country_code' => $country_code ? $country_code : '',
				'phone' => $phone ? $phone : '',
			];
	}

	public static function dillerapp_show_dimension_details($selected_department = '')
	{


		$mDta = array();
		$request = self::dillerapp_get_require_param_function();
		$mDta = self::dillerapp_post_request_function($request, 'PosV1/getStoreDetails');
		if ($mDta && isset($mDta->result->segment_details)) {
			$all_sm_names = array();
			foreach ($mDta->result->segment_details as $segment_details) {
				$segment_details = json_encode($segment_details);
				$segment_details = json_decode($segment_details, true);
				$is_required_lable = $segment_details['is_required']==1 ? "*" : "";
           		$is_required =$segment_details['is_required']==1 ? "required" : "";
                if($segment_details['is_visible_follower']==1){


				switch ($segment_details['segment_type']) {
					case 1:

						$all_sm_names[] = '1#' . $segment_details['segment_id'];

						$fl_value =  array_key_exists('follower_segment_values', $segment_details) ? $segment_details['follower_segment_values'] : '';

						echo  '<div class="diller-form-group"> <label for="">' . $segment_details['segment_name'] . '</label><span class="diller_required">' . $is_required_lable . '</span>';

						echo  '<input type="text"  name="1#' . $segment_details['segment_id'] . '" id="" value="' . $fl_value . '" placeholder="" autocomplete="on" class="diller-form-control" ' . $is_required . ' >';

						echo '</div>';

						break;
					case 2:
						$all_sm_names[] = '2#' . $segment_details['segment_id'];

						$fl_value =  array_key_exists('follower_segment_values', $segment_details) ? $segment_details['follower_segment_values'] : '';

						echo  '<div class="diller-form-group"> <label for="">' . $segment_details['segment_name'] . '</label><span class="diller_required">' . $is_required_lable . '</span>';

						echo  '<input type="text"  name="2#'.$segment_details['segment_id'].'" id="" value="'.$fl_value.'" placeholder="dd-mm-yyyy hh:ii:ss" autocomplete="on" class="diller-form-control dimension_value1" '.$is_required.' >  ';

						echo '</div>';

						break;
					case 3:
						$all_sm_names[] = '3#' . $segment_details['segment_id'];

						echo  '<div class=""> <label for="">' . $segment_details['segment_name'] . '</label><span class="diller_required">' . $is_required_lable . '</span>';

						foreach ($segment_details['segment_values'] as $key => $value) {

							$checked = '';

							if (array_key_exists('follower_segment_values', $segment_details) && $value['segment_values'] == $segment_details['follower_segment_values']) {
								$checked = "checked";
							}

							echo '<label class="diller-radio">                            
                        <input type="radio"  name="3#' . $segment_details['segment_id'] . '" id="" value="' . $value['segment_values'] . '" ' . $checked . ' ' . $is_required . ' >
                        <span class="diller-radio-checkmark"></span>
                        <span class="diller-label-text">' . $value['segment_values'] . '</span>
                      </label>';
						}

						echo '</div>';

						break;
					case 4:
						$all_sm_names[] = '4#' . $segment_details['segment_id'];

						echo  '<div class=""> <label for="">' . $segment_details['segment_name'] . '</label><span class="diller_required">' . $is_required_lable . '</span>';

						foreach ($segment_details['segment_values'] as $key => $value) {

							$checked = '';

							if (array_key_exists('follower_segment_values', $segment_details) && in_array($value['segment_values'], $segment_details['follower_segment_values'])) {
								$checked = "checked";
							}

							echo '<label class="diller-checkbox">                            
                            <input type="checkbox" name="4#' . $segment_details['segment_id'] . '[]" id="" value="' . $value['segment_values'] . '" ' . $checked . ' ' . $is_required . ' >
                            <span class="diller-checkmark"></span>
                            <span class="diller-label-text">' . $value['segment_values'] . '</span>
                          </label>';
						}

						echo '</div>';

						break;
					case 5:

						$all_sm_names[] = '5#' . $segment_details['segment_id'];

						echo 	'<div class="diller-form-group">
                        	<div class="select">
                            	<label>' . $segment_details['segment_name'] . '</label>
                            	<select name="5#' . $segment_details['segment_id'] . '" class="selectpicker diller-form-control1 diller-selectbox" ' . $is_required . ' data-live-search="true" >';
						foreach ($segment_details['segment_values'] as $key => $value) {
							$selected = '';
							if (array_key_exists('follower_segment_values', $segment_details) && $value['segment_values'] == $segment_details['follower_segment_values']) {
								$selected = "selected";
							}
							echo '<option value="' . $value['segment_values'] . '" ' . $selected . ' >' . $value['segment_values'] . '</option>';
						}

						echo '</select>
                        	</div>
                    	</div>';
						break;
				}
			}

			echo ' <input type="hidden" name="all_sm_names" value="' . implode(',', $all_sm_names) . '"  >';
		}

		//if ($mDta && (array_key_exists('department_details', $mDta->result))) {
			//For Checbox
			if (isset($mDta->result->department_details->department_type) && $mDta->result->department_details->department_type == 4) {
?>
				<label for=""><?php echo $mDta->result->department_details->department_name; ?></label><span class="diller_required"></span>
				<?php
				foreach ($mDta->result->department_details->department_values as $key => $value) {
				?>
					<label class="diller-checkbox">
						<?php
						$checked  = '';
						if (isset($mDta->result->department_details->follower_department_values) && in_array($value->department_values, $mDta->result->department_details->follower_department_values)) {

							$checked = 'checked';
						} else if ($selected_department == $value->department_value_id2) {
							$checked = 'checked disabled';
						}

						?>

						<input type="checkbox" name="department_id[]" id="" value="<?php echo $value->department_value_id2; ?>" <?= $checked ?>>
						<span class="diller-checkmark"></span>
						<span class="diller-label-text"><?php echo $value->department_values . " &nbsp "; ?></span>
					</label>
		<?php }
			//}
		}
	}
	}

	public static function dillerapp_show_checkboxes($type = '')
	{
		$diller_loyalty_program_status = Dillerapp::dillerapp_checked_user_loyalty_status();
		$admin_response = self::diller_wc_admin_details();
		$language = $admin_response['language'];
		$store_pin = $admin_response['store_id'];

		$user = wp_get_current_user();
		$disable = '';
		if ($user->loyalty_program == 1 && $type == 'checkout') {
			$disable = 'disabled';
		}

		$customer_user_id = $user->ID;
		$user_follower_id = get_user_meta($customer_user_id, 'user_follower_id', true);

		$request = self::dillerapp_get_require_param_function();
		if ($request) {
			$storeData = self::dillerapp_post_request_function($request, 'PosV1/getStoreDetails');
			$store_name = '';
			if ($storeData && $storeData->status == 200) {
				$store_name = $storeData->result->store_name ? $storeData->result->store_name : '';
			}
		}

		?>
		<?php if ($type == 'checkout') {
			if ($diller_loyalty_program_status == 0) { ?>
				<label class="diller-checkbox">
					<input type="checkbox" name="privacy_policy" id="privacy_policy" value="Yes" <?php echo ($user->loyalty_program == 1 || (isset($_POST['privacy_policy']) && $_POST['privacy_policy'] == "Yes") ? 'checked' : ''); ?> <?php echo ($type == "subscription" ? 'required' : ''); ?> <?php echo $disable; ?>>
					<span class="diller-checkmark"></span>
					<span class="diller-label-text"><?= PRIVACY_POLICY_1 . $store_name . ' ' . PRIVACY_POLICY_2 . ' <a class="diller_links" target="_blank" href="https://diller.app/follower/privacyPolicy/' . base64_encode($store_pin . '$$$' . $language) . '">' . PRIVACY_POLICY_3 . '</a>' ?></span><span class="diller-form-required">*</span>
				</label>
				<label class="diller-checkbox">
					<input type="checkbox" name="is_purchase_history" id="is_purchase_history" value="Yes" <?php echo ($user->is_purchase_history == 1 || (isset($_POST['is_purchase_history']) && $_POST['is_purchase_history'] == "Yes") ? 'checked' : ''); ?> <?php echo $disable; ?>>
					<span class="diller-checkmark"></span>
					<span class="diller-label-text"><?= PURCHASE_HISTORY ?></span>
				</label>
			<?php 	}
		} else { ?>
			<label class="diller-checkbox">
				<input type="checkbox" name="privacy_policy" id="privacy_policy" value="Yes" <?php echo ($user->loyalty_program == 1 || (isset($_POST['privacy_policy']) && $_POST['privacy_policy'] == "Yes") ? 'checked' : ''); ?> <?php echo ($type == "subscription" ? 'required' : ''); ?> <?php echo $disable; ?>>
				<span class="diller-checkmark"></span>
				<span class="diller-label-text"><?= PRIVACY_POLICY_1 . $store_name . ' ' . PRIVACY_POLICY_2 . ' <a class="diller_links" target="_blank" href="https://diller.app/follower/privacyPolicy/' . base64_encode($store_pin . '$$$' . $language) . '">' . PRIVACY_POLICY_3 . '</a>' ?></span><span class="diller-form-required">*</span>
			</label>
			<label class="diller-checkbox">
				<input type="checkbox" name="is_purchase_history" id="is_purchase_history" value="Yes" <?php echo ($user->is_purchase_history == 1 || (isset($_POST['is_purchase_history']) && $_POST['is_purchase_history'] == "Yes") ? 'checked' : ''); ?> <?php echo $disable; ?>>
				<span class="diller-checkmark"></span>
				<span class="diller-label-text"><?= PURCHASE_HISTORY ?></span>
			</label>
		<?php } ?>
		<?php if ($user->loyalty_program == 1 && $type == 'account') { ?>
			<label class="diller-checkbox">
				<input type="checkbox" name="receive_sms" id="custom_sms" value="Yes" <?php echo ($user->sms_check == 1 ? 'checked' : ''); ?>>
				<span class="diller-checkmark"></span>
				<span class="diller-label-text"><?= NEWS_OFFER_SMS ?></span>
			</label>

			<label class="diller-checkbox">
				<input type="checkbox" name="receive_email" id="custom_email" value="Yes" <?php echo ($user->email_check == 1 ? 'checked' : ''); ?>>
				<span class="diller-checkmark"></span>
				<span class="diller-label-text"><?= NEWS_OFFER ?></span>
			</label>
<?php }
	}

	public static function dillerGenerateStrongPassword($length = 9, $add_dashes = false, $available_sets = 'luds')
	{
		$sets = array();
		if (strpos($available_sets, 'l') !== false)
			$sets[] = 'abcdefghjkmnpqrstuvwxyz';
		if (strpos($available_sets, 'u') !== false)
			$sets[] = 'ABCDEFGHJKMNPQRSTUVWXYZ';
		if (strpos($available_sets, 'd') !== false)
			$sets[] = '23456789';
		if (strpos($available_sets, 's') !== false)
			$sets[] = '!@#$%&*?';

		$all = '';
		$password = '';
		foreach ($sets as $set) {
			$password .= $set[array_rand(str_split($set))];
			$all .= $set;
		}

		$all = str_split($all);
		for ($i = 0; $i < $length - count($sets); $i++)
			$password .= $all[array_rand($all)];

		$password = str_shuffle($password);

		if (!$add_dashes)
			return $password;

		$dash_len = floor(sqrt($length));
		$dash_str = '';
		while (strlen($password) > $dash_len) {
			$dash_str .= substr($password, 0, $dash_len) . '-';
			$password = substr($password, $dash_len);
		}
		$dash_str .= $password;
		return $dash_str;
	}
	public static function store_details_btn()
	{
		$request = self::dillerapp_get_require_param_function();
		$storeData = self::dillerapp_post_request_function($request, 'PosV1/getStoreDetails');
		if($storeData && $storeData->status==200) {
		    return $storeData->result->point_system;
		}
	}
	public static function store_details_background_btn()
	{
		$request = self::dillerapp_get_require_param_function();
		$storeData = self::dillerapp_post_request_function($request, 'PosV1/getStoreDetails');
		return $storeData->result->wp_submit_button_color;	
	}
	public static function store_details_point_bar_color()
	{
		$request = self::dillerapp_get_require_param_function();
		$storeData = self::dillerapp_post_request_function($request, 'PosV1/getStoreDetails');
		return $storeData->result->point_bar_color;	
	}
	public static function get_store_details()
	{
		$request = self::dillerapp_get_require_param_function();
		$storeData = self::dillerapp_post_request_function($request, 'PosV1/getStoreDetails');
		return $storeData;	
	}
	public static function get_system_info() {
			
			$system_info = array( 
				'php_memory_limit'   => array(
					'title'    => esc_html__( 'PHP Memory Limit', 'diller-app' ),
					'value'    => size_format( wp_convert_hr_to_bytes( @ini_get( 'memory_limit' ) ) ),
					'required' => '1024',
					'pass'     => ( wp_convert_hr_to_bytes( @ini_get( 'memory_limit' ) ) >= 1073741824 ) ? true : false,
					'notice'   => esc_html__( 'The current value is insufficient to properly support the plugin. Please adjust this value to 1024 in order to meet the plugin requirements. ', 'diller-app' )
				)
			);
				return $system_info;
			}
}
