<?php

/**
 * Plugin Name: Diller Loyalty 
 * Plugin URI: https://diller.app/
 * Description: Diller is a loyalty platform for businesses. With the Diller Wordpress plugin you will be able to start onboarding your customers to members, share coupons and member status.
 * Version: 1.6.1
 * Author: Diller
 * Author URI: https://diller.no/
 **/

if (!defined('ABSPATH')) {
  exit; // Exit if accessed directly
}
if (!defined('DILLERAPP_FILE')) {
  define('DILLERAPP_FILE', __FILE__);
}

if (!defined('DILLERAPP_ABSPATH')) {
  define('DILLERAPP_ABSPATH', dirname(DILLERAPP_FILE) . '/');
}

if (!defined('DILLERAPP_DIR')) {
  define('DILLERAPP_DIR', plugin_dir_path(__FILE__));
}

if (!defined('DILLERAPP_URL')) {
  define('DILLERAPP_URL', plugins_url('/', __FILE__));
}

// Only be active if Woocommerce is active
$activeplugins =  apply_filters('active_plugins', get_option('active_plugins'));
$activesiteplugins = apply_filters('active_sitewide_plugins', get_site_option('active_sitewide_plugins'));
if ($activesiteplugins) {
  $activeplugins = array_merge($activeplugins, array_keys($activesiteplugins));
}

if (in_array('woocommerce/woocommerce.php', $activeplugins)) {
  require(dirname(__FILE__) . '/class/class-diller-logger.php');
  require(dirname(__FILE__) . '/pck-functions.php');
  require_once(dirname(__FILE__) . "/Dillerapp-class.php");

  /* Instantiate the singleton, stash it in a global and add hooks. IOK 2018-02-07 */
  global $Diller_App;
  $Diller_App = Diller_App::instance();
  register_activation_hook(__FILE__, array($Diller_App, 'activate'));
  register_deactivation_hook(__FILE__, array($Diller_App, 'deactivate'));
  register_uninstall_hook(__FILE__, 'Diller_App::uninstall');

  if (is_admin()) {
    add_action('admin_init', array($Diller_App, 'admin_init'));
  } else {
    add_action('wp_footer', array($Diller_App, 'footer'));
  }
  add_action('init', array($Diller_App, 'init'));
  add_action('plugins_loaded', array($Diller_App, 'plugins_loaded'));
  add_action('woocommerce_loaded', array($Diller_App, 'woocommerce_loaded'));
}
function dillerapp_insert_user(){
  $admin_response = Dillerapp::diller_wc_admin_details();
    $request = array(
      'store_id' => $admin_response['store_id']
    );
    $data = http_build_query($request);
    $res_count = Dillerapp::dillerapp_post_request_function($data, 'PosV1/getMemberCount');
    $res = Dillerapp::dillerapp_post_request_function($data, 'PosV1/getAllMemberList');
    if($res && $res->status == 200){
    foreach ( $res->result as $key => $value ) {
      
          $first_name   = $value->first_name;  
          $last_name    = $value->last_name;  
          $user_login   = $value->email; 
          $user_email   = $value->email;
          $country_code = $value->country_code;
          $mob          = $value->phone;
          $phone        = $value->country_code.$value->phone;
          $address      = $value->address;
          $city         = $value->city;
          $zip_code     = $value->zip_code;
          $country      = $value->country;
          $diller_retail= $value->email;
          $receive_sms  = isset($value->receive_sms) && $value->receive_sms=='Yes'?1:0;
          $receive_email= isset($value->receive_email) && $value->receive_email=='Yes'?1:0;
          $is_purchase_history=isset($value->is_purchase_history) && $value->is_purchase_history== 'Yes'  ? 1: 0;
          
                $password     = wp_generate_password( 12, false );
                $new_user_id  = wp_insert_user(array(
                          'first_name'    => $first_name,
                          'last_name'     => $last_name,
                          'user_login'    => $user_email,
                          'user_pass'     => $password,
                          'user_email'    => $user_email,
                          'user_registered' => date('Y-m-d H:i:s'),
                          'role'        => 'customer'
                        )
                      );
                update_user_meta($new_user_id,'billing_address_1',$address);
                update_user_meta($new_user_id,'billing_city',$city);
                update_user_meta($new_user_id,'billing_postcode',$zip_code);
                update_user_meta($new_user_id,'billing_country',$country);
                update_user_meta($new_user_id,'billing_email',$user_email);
                update_user_meta($new_user_id,'country_code',$country_code);
                update_user_meta($new_user_id,'phone',$mob);
                update_user_meta($new_user_id, 'mob_no', $phone );
                update_user_meta($new_user_id, 'loyalty_program', 1 );
                update_user_meta($new_user_id, 'sms_check', $receive_sms);
                update_user_meta($new_user_id, 'email_check', $receive_email );
                update_user_meta($new_user_id,'is_purchase_history',$is_purchase_history); 
                update_user_meta($new_user_id,' _order_count',0);
              }
          $items = array();
          $items[] = $value->user_follower_id;
           
          $request1 = array(
          'store_id' => $admin_response['store_id'],
          'user_follower_id' => $items
         );
          $update_res = Dillerapp::dillerapp_post_request_function($request1, 'PosV1/updateWpImportStatus');
     
  ?>
    <div class="diller-container"> <span class="diller-success-admin demo"><?= ($admin_response['language'] == 2 ? 'We have imported all the diller members' : 'Suksess! Vi har importert medlemmene.'); ?></span></div><br/>
  <?php }
}

