<?php
function dillerapp_admin_page() {
  $settings = get_diller_settings();

  //$choose_language_id = $settings['_choose_language_id'];
  $ciphering = Dillerapp::DILLER_CIPHERING;
  //$iv_length = openssl_cipher_iv_length(Dillerapp::DILLER_CIPHERING);
  $options = Dillerapp::DILLER_CI_OPTION;
  $encryption_iv = Dillerapp::DILLER_ENCRYPTION_IV;
  $encryption_key = Dillerapp::DILLER_ENCRYPTION_KEY;
  //$user = wp_get_current_user();

  $api_response_message = '';
  $erros = [];

  if (isset($_POST['diller_admin_submit'])) {
    if (empty($_POST['x-api-key'])) {
      $erros['x-api-key'] = 'Missing api key';
    }

    if (empty($_POST['_store_pin'])) {
      $erros['_store_pin'] = 'Missing Store ID';
    }

    if (empty($erros)) {
      $post_store_pin = sanitize_text_field($_POST['_store_pin']);
      $post_x_api_key = sanitize_text_field($_POST['x-api-key']);
      $post_disable_skeleton_css = (!empty($_POST['_disable_skeleton_css']) ? sanitize_text_field($_POST['_disable_skeleton_css']) : 'off');
      $post_disable_multisite = (!empty($_POST['_disable_multisite']) ? sanitize_text_field($_POST['_disable_multisite']) : 'off');

      $body = array('store_id' => $post_store_pin);
      $headers = array('x-api-key' => $post_x_api_key);
      $args = array(
        'body'        => $body,
        'timeout'     => '5',
        'redirection' => '5',
        'httpversion' => '1.0',
        'blocking'    => true,
        'headers'     => $headers,
        'cookies'     => array(),
      );
      $response = wp_remote_post('https://diller.app/api/PosV1/storeIDAuth', $args);

      $res = json_decode($response['body']);
      $admin_response=Dillerapp::diller_wc_admin_details();
      $requesta = array(
                    'store_id' => $admin_response['store_id']
                  );
      
      if (!empty($res) && $res->status == 200) {
        $output12 = openssl_encrypt($post_x_api_key, $ciphering, $encryption_key, $options, $encryption_iv);
        $settings['_store_pin_id'] = $res->result->store_pin;
        $settings['x_api_key'] = $output12;
        $settings['_choose_language_id'] = $res->result->store_language;
        $settings['_disable_skeleton_css'] = $post_disable_skeleton_css == 'on' ? 1 : 0;
        $settings['_disable_multisite'] = $post_disable_multisite == 'on' ? 1 : 0;

        $api_response_message = "<div class='diller-success-admin'>" . sanitize_text_field($res->message) . "</div>";
        update_option('dillerapp_settings', $settings);
      } else {
        $api_response_message = "<div class='diller-error-admin'>" . sanitize_text_field($res->message) . "</div>";
      }
    }
  }
?>
<style type="text/css">
  #footer-thankyou{
    display: none;
  }
</style>
<div class="diller-sky-bg">
    <div class="diller-container diller-header">
    <span><img src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/logodiller.svg'; ?>"/> 
            <span class="diller-header-text">Thanks for installing Diller Loyalty</span>
        </span>
        <div class="diller-message-admin-box">
            <?php echo $api_response_message; ?>
        </div>
    </div>
    <?php if(array_key_exists('dillerapp_insert_user', $_POST)) { 
                   dillerapp_insert_user(); 
                } ?>
            
    <div class="diller-container">
        <div class="diller-tab">
        <a href="#"class="diller-tab-link active" onclick="dillerTabOpen(event, 'woocommerce')" id="defaultOpen">WooCommerce</a>
  <a href="#"  class="diller-tab-link" onclick="dillerTabOpen(event, 'import')">Import Data</a>
        </div>
        <div id="woocommerce" class="tabcontent" style="display: block;">   
        <div class="diller-container">
        <div class="diller-row">
            <div class="diller-col-lg-7">
                <h4 class="diller-heading-tab">Connect your store to WooCommerce</h4>
                <span class="diller-p-tab">Contact your partner to get your API-Key and Store ID.</span> 
                       
                <div class="">
                 <?php 
                 $store_pin_id = $settings['_store_pin_id'];
                 $x_api_key = $settings['x_api_key'];
                 $disable_skeleton_css = $settings['_disable_skeleton_css'];
                 $disable_multisite = $settings['_disable_multisite'];

                 $decryption = openssl_decrypt($x_api_key, $ciphering, $encryption_key, $options, $encryption_iv);?>
                    <div class="diller-col-lg-9">
                      <form class="diller-form" action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
                            <div class="diller-form-group">
                                <label>API-Key <?php echo key_exists('x-api-key', $erros) ? '<span class="notice notice-info">' . $erros['x-api-key'] . '</span>' : ''; ?></label><br>
                                <input type="password" name="x-api-key" value="<?php echo $decryption; ?>" class="diller-form-control">
                            </div>
                            <div class="diller-form-group">
                                <label>Store ID <?php echo key_exists('_store_pin', $erros) ? '<span class="notice notice-info">' . $erros['_store_pin'] . '</span>' : ''; ?></label><br>
                                <input type="text" name="_store_pin" value="<?php echo $store_pin_id ?>" class="diller-form-control">
                            </div>
                            <label class="diller-custom-checkbox">
                                <input type="checkbox" name="_disable_skeleton_css" <?php echo $disable_skeleton_css == 1 ? 'checked' : '' ?>>
                                <span class="diller-custom-checkmark"></span>
                                <span class="diller-label-text">Disable skeleton CSS</span>
                            </label>
                            <label class="diller-custom-checkbox">
                                <input type="checkbox" name="_disable_multisite" <?php echo $disable_multisite == 1 ? 'checked' : '' ?>>
                                <span class="diller-custom-checkmark"></span>
                                <span class="diller-label-text">PCK Nettbutikk</span>
                            </label>

                            <a href="#"><button type="submit" name="diller_admin_submit" class="diller-btn">Save Settings</button></a>
                        </form>
                    </div>
                </div>
                <hr class="diller-section-border">
            </div>
            <div class="diller-col-lg-5">
              <img class="diller-partner-img" src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/onboarding-back.svg'; ?>"/>
            </div>
            <div class="diller-col-lg-7">
                <?php
                $admin_response = Dillerapp::diller_wc_admin_details();
                if(!empty($admin_response['store_id'])){?>
                  <h4 class="diller-sub-heading">Subscription Page</h4>
                  <span class="diller-p-tab">Link to the subscription page where customers can join your loyalty program.</span>
                  <a class="diller-link" href="<?= site_url('/').'innmelding-kundeklubb'; ?>"><?= site_url('/').'innmelding-kundeklubb'; ?></a> 
              <?php } ?>             
              <p class="diller-version">Version 1.6.1 <span style="margin-left: 10px;">Server :<?php echo Dillerapp::SERVER; ?></span></p>
            </div>
        </div>
        </div>
    </div>
    <?php $admin_response = Dillerapp::diller_wc_admin_details(); ?>
    <div id="import" class="tabcontent">
        <div class="diller-container">
        <div class="diller-row">
        <div class="diller-col-lg-7">
          <h4 class="diller-heading-tab"><?= ($admin_response['language'] == 2 ? 'Connect your store to import members' : 'Koble til din butikk for å importere medlemmer'); ?></h4>
          <span class="diller-p-tab"><?= ($admin_response['language'] == 2 ? 'Contact your partner to get started with importing members.' : 'Kontakt din partner for å få hjelp til å importere medlemmer fra Diller.'); ?></span>
            <?php $system_info = Dillerapp::get_system_info(); ?>
      
           <div class="qodef-cd-box-inner">
          <?php foreach ($system_info as $system_info_key => $system_info_value):
            $class = (isset($system_info_value['pass']) && !$system_info_value['pass']) ? 'qodef-cdb-value-false' : '';
            ?>
            <div class="qodef-cd-box-row">
              <div class="qodef-cdb-label"><?php echo esc_attr($system_info_value['title']); ?> :</div>  <div class="qodef-cdb-value <?php echo esc_attr($class); ?>"><span>  <?php echo wp_kses_post($system_info_value['value']); ?></span>  (Required 1024MB)</div>
            </div>
              <div class="diller-config-code">Please add this code in your wp-config.php file:
                <p>define('WP_MEMORY_LIMIT', '1024M');</p>
              </div>
          <?php endforeach; ?>
        </div> 
            <div class="diller-col-lg-9">
            <?php 
             $res_count = Dillerapp::dillerapp_post_request_function($admin_response, 'PosV1/getMemberCount');
             if($res_count){
             $diller_counnt = $res_count->result;
             }
             if(!empty($admin_response['store_id'])){  ?>
            <button type="button" class="diller-btn diller-margin" id="startpopup" data-toggle="modal" data-target="#exampleModalCenter"><?= ($admin_response['language'] == 2 ? 'Start import' : 'Start importering'); ?></button>
              <div class="modal fade white-modal-blur" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
                  <div class="modal-dialog modal-dialog-centered text-center" role="document">
                    <div class="modal-content">
                      <div class="modal-body">
                        <p class="diller-heading"><?= ($admin_response['language'] == 2 ? 'Are you sure, import all the users form diller loyalty program?' : 'Er du helt sikker på at du ønsker å importere alle medlemmene fra Diller til Wordpress?'); ?></p>                       
                        <p class="diller-heading"><?php if($admin_response['language'] == 2){ ?>
                            We have <?php  echo $diller_counnt; ?>  members in diller Loyalty program.
                            <?php } else { ?>
                            Du har <?php echo $diller_counnt;?> medlemmer i Diller.
                            <?php } ?></p>
                      </div>
                      <div class="diller-modal-footer">
                        <button type="button" class="diller_send_sms_link" data-dismiss="modal"><?= ($admin_response['language'] == 2 ? 'No, Cancel' : 'Nei, avbryt'); ?></button>
                        <form method="post" class="diller-form" id="testfrom"> 
                         <a href="#"><button type="submit" class="diller-btn"  name="dillerapp_insert_user" id="save_insert" value="dillerapp_insert_user"><?= ($admin_response['language'] == 2 ? 'Start import' : 'Start importering'); ?></button></a>
                        </form>
                      </div>   
                    </div>
                  </div>
                </div>
               
                 <!-- Modal template -->
                <div class="modal fade white-modal-blur" id="please-wait">
                <div class="modal-dialog modal-dialog-centered modal-md">
                <div class="modal-content white-card">
                    <div class="modal-body pl-4 pr-4 pt-4 pb-4">  
                        <div class="row">
                           <div class="dillerb-col-lg-10 m-auto dillerb-col-md-12">
                              <h6 class="mb-5 mt-2 text-center diller-heading"><?= ($admin_response['language'] == 2 ? 'Please wait.. we are importing all the diller!' : 'Vennligst vent.. vi importerer medlemmene.'); ?></h6>
                              <img class="m-auto w-75 d-block" src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/please-wait-modal.gif'; ?>"/>
                           </div>
                           <div class="dillerb-col-lg-9 m-auto d-block text-center dillerb-col-md-8">
                                  <div class="diller-modal-progress mt-5 mb-3" id="diller-progress-bar" style="width: 0%" >
                                    <div class="diller-progress-active"  ></div>
                                  </div>
                                  <h6 class="mb-3 mt-2 text-center diller-heading" id="diller-progress-number" >0%</h6>
                           </div>
                        </div>
                    </div>
                </div>
                </div>
                </div>
                <!-- Modal template -->
                
           
            <?php } else {  ?>
            <span class="diller-not-connect"><?= ($admin_response['language'] == 2 ? 'Please connect to diller store' : 'Du må koble til butikken i Diller for å bruke import funksjonaliteten.'); ?></span>

            <?php  } ?>
          
          <hr class="diller-section-border">
        </div>
         </div>
        <div class="diller-col-lg-5">
          <img class="diller-partner-img" src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/onboarding-back.svg'; ?>"/>
        </div>

      </div>
    </div>
  </div>
        </div>
    </div>
 </div>
<?php
}
?>
