<?php
function dillerapp_subscription()
{
  if (!is_user_logged_in()) {
    $admin_response = Dillerapp::diller_wc_admin_details();
    $language = $admin_response['language'];
    $is_readonly_phone = '';
    if (isset($_GET['q1'])) {
      $q1_sanitize_value = sanitize_text_field($_GET['q1']);
      if (isset($q1_sanitize_value)) {
        $_POST['phone'] = base64_decode($q1_sanitize_value);
        $is_readonly_phone = 'readonly';
      } else {
        $_POST['phone'] = '+47';
      }
    }
    $is_readonly = '';

    if (isset($_GET['refer_id'])) {
      $refer_id_sanitize = sanitize_text_field($_GET['refer_id']);
      $store_pin = $admin_response['store_id'];
      $data1 = array('store_id' => $store_pin, 'refer_id' => $refer_id_sanitize);
      $res_refer = Dillerapp::dillerapp_post_request_function($data1, 'PosV1/getReferFriendDetails');

      if ($res_refer && $res_refer->status == 200) {
        $_POST['email'] = $res_refer->result->email;
        $_POST['first_name'] = $res_refer->result->first_name;
        $_POST['last_name'] = $res_refer->result->last_name;
        $is_readonly = 'readonly';
      }
    }

    if ($admin_response && isset($admin_response['store_id']) && $admin_response['store_id']) { ?>
      <p class="diller_p_tag"> <?php dillerapp_show_error_messages(); ?> </p>
      <form action="" id="diller-subscription" method="post" onsubmit="return getCountryCode() , checkEmail(), checkPhone()">
        <div class="container">
          <input type="hidden" name="country_code" id="country_code">
          <div class="diller-form-group">
            <label><?= PHONE; ?> <span class="diller-form-required">*</span></label>
            <?php
            $phone_post = '';
            $phone_post .= isset($_POST['country_code']) ? $_POST['country_code'] : '';
            $phone_post .= isset($_POST['phone']) ? $_POST['phone'] : '';
            $phone_post = $phone_post != '' ? $phone_post : "+47";
            ?>
            <input type="tel" id="phone" name="phone" value="<?php echo $phone_post; ?>" class="diller-form-control" <?= $is_readonly_phone; ?> required onkeypress="return isNumberKey(event)">
            <span class="diller-error" id="phone_error"></span>
          </div>

          <div class="diller-form-group">
            <label><?= EMAIL; ?> <span class="diller-form-required">*</span></label>
            <input type="email" id="email" placeholder="<?= EMAIL; ?>" name="email" class="diller-form-control" value="<?php if (isset($_POST['email'])) echo $_POST['email']; ?>" <?= $is_readonly; ?> required>
            <?php if (empty($admin_response['multisite_disable'])) { ?>
              <span class="diller-error" id="email_error"></span>
            <?php } ?>
          </div>

          <div class="diller-form-group">
            <label><?= FIRST_NAME; ?> <span class="diller-form-required">*</span></label>
            <input type="text" placeholder="<?= FIRST_NAME; ?>" id="diller_follower_first_name" name="first_name" class="diller-form-control" value="<?php if (isset($_POST['first_name'])) echo $_POST['first_name']; ?>" required>
          </div>

          <div class="diller-form-group">
            <label><?= LAST_NAME; ?> <span class="diller-form-required">*</span></label>
            <input type="text" placeholder="<?= LAST_NAME; ?>" id="diller_follower_last_name" name="last_name" class="diller-form-control" value="<?php if (isset($_POST['last_name'])) echo $_POST['last_name']; ?>" required>
          </div>

          <div class="diller-form-group">
            <label><?= BIRTHDATE ?></label>
            <input type="text" placeholder="<?= BIRTHDATE ?>" name="date_of_birth" id="date_of_birth" class="diller-form-control" value="<?php if (isset($_POST['date_of_birth'])) echo $_POST['date_of_birth']; ?>">
            <span class="diller-error" id="dob_error"></span>
          </div>

          <div class="diller-form-group">
            <div class="select">
              <label><?= GENDER ?></label>
              <select name="gender" class="diller-form-control diller-selectbox">
                <option value=""><?= SELECTBOX ?></option>
                <option value="1" <?= isset($_POST['gender']) && $_POST['gender'] == 1 ?  "selected" : '' ?>><?= MALE ?></option>
                <option value="2" <?= isset($_POST['gender']) && $_POST['gender'] == 2 ?  "selected" : '' ?>><?= FEMALE ?></option>
                <option value="3" <?= isset($_POST['gender']) && $_POST['gender'] == 3 ?  "selected" : '' ?>><?= NONE_OF_THESE ?></option>
              </select>
            </div>
          </div>

          <div class="diller-form-group">
            <label><?= ADDRESS ?></label>
            <input type="text" placeholder="<?= ADDRESS ?>" id="diller_follower_address" name="address" class="diller-form-control" value="<?php if (isset($_POST['address'])) echo $_POST['address']; ?>">
          </div>

          <div class="diller-form-group">
            <label><?= POSTAL_CODE ?></label>
            <input type="text" placeholder="<?= POSTAL_CODE ?>" id="diller_follower_zipcode" name="zip_code" class="diller-form-control" value="<?php if (isset($_POST['zip_code'])) echo $_POST['zip_code']; ?>">
          </div>

          <div class="diller-form-group">
            <label><?= CITY ?></label>
            <input type="text" placeholder="<?= CITY ?>" id="diller_follower_city" name="city" class="diller-form-control" value="<?php if (isset($_POST['city'])) echo $_POST['city']; ?>">
          </div>
          <?php
          if (isset($_GET['q'])) {
            $q_sanitize_value = sanitize_text_field($_GET['q']);
            if (isset($q_sanitize_value)) {
              $q_hidden_val = base64_decode($q_sanitize_value);
            } else {
              $q_hidden_val = '';
            }
          } else {
            $q_hidden_val = '';
          }

          if (isset($_GET['q2'])) {
            $q2_sanitize_value = sanitize_text_field($_GET['q2']);

            if (isset($q2_sanitize_value)) {
              $q2_hidden_val = base64_decode($q2_sanitize_value);
            } else {
              $q2_hidden_val = '';
            }
          } else {
            $q2_hidden_val = '';
          }
          ?>

          <input type="hidden" value="<?= $q_hidden_val;?>" name="q_hidden">
          <?php Dillerapp::dillerapp_show_dimension_details($q2_hidden_val);
            Dillerapp::dillerapp_show_checkboxes('subscription');
            $point_bar_color=Dillerapp::store_details_background_btn();
          ?>
        <input type="hidden" value="<?= isset($refer_id_sanitize) ? $refer_id_sanitize : '' ; ?>" name="refer_id">
        <input type="hidden" name="pippin_subscribe_nonce" value="<?php echo wp_create_nonce('pippin-subscribe-nonce'); ?>"/>
        <a href="#"><button type="submit" name="subscribe" class="diller-btn diller-w-100 diller-mt-3 diller-mb-3" style="background-color: <?php echo $point_bar_color ?>;"><?= SUBSCRIBE ?></button></a>
        </div>
      </form>
    <?php } else { ?>
      <h4 class="diller-w-100 diller-error">Please connect your store with DillerLoyalty to access this page.</h4>
    <?php }
    ?>
  <?php
  } else {
    $settings = get_diller_settings();
    $language = $settings['_choose_language_id'];
  ?>
    <h3 class="diller_join_program diller_h3_tag"><?= JOIN_LOYALTY_PROGRAM ?></h3>
<?php
    echo ALREADY_LOGGED;
  }
}
add_shortcode('short_subscription', 'dillerapp_subscription');
?>